# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper


class AutoRenewCardRequestAutoRenewCardsItems(object):

    """Implementation of the 'AutoRenewCardRequestAutoRenewCardsItems' model.

    TODO: type model description here.

    Attributes:
        account_number (str): Account Number of the customer. Optional if
            AccountId is passed, else Mandatory.
        account_id (int): Account Id of the customer. Optional if
            AccountNumber is passed, else Mandatory.
        pan (str): PAN of the card. Optional if CardId is passed, else
            Mandatory.
        panid (float): Card PAN ID. Optional if CardId is given, else
            mandatory. Note: PANID is ignored if CardId is given.
        card_id (int): Card Id of the card. Optional if PAN is passed, else
            Mandatory.
        reissue_setting (bool): Reissue setting of the card.   Values:  True –
            Card will be Reissued when nearing its expiry date  False – Card
            will not be Reissued  Mandatory

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "reissue_setting": 'ReissueSetting',
        "account_number": 'AccountNumber',
        "account_id": 'AccountId',
        "pan": 'PAN',
        "panid": 'PANID',
        "card_id": 'CardId'
    }

    _optionals = [
        'account_number',
        'account_id',
        'pan',
        'panid',
        'card_id',
    ]

    def __init__(self,
                 reissue_setting=None,
                 account_number=APIHelper.SKIP,
                 account_id=APIHelper.SKIP,
                 pan=APIHelper.SKIP,
                 panid=APIHelper.SKIP,
                 card_id=APIHelper.SKIP):
        """Constructor for the AutoRenewCardRequestAutoRenewCardsItems class"""

        # Initialize members of the class
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if pan is not APIHelper.SKIP:
            self.pan = pan 
        if panid is not APIHelper.SKIP:
            self.panid = panid 
        if card_id is not APIHelper.SKIP:
            self.card_id = card_id 
        self.reissue_setting = reissue_setting 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        reissue_setting = dictionary.get("ReissueSetting") if "ReissueSetting" in dictionary.keys() else None
        account_number = dictionary.get("AccountNumber") if dictionary.get("AccountNumber") else APIHelper.SKIP
        account_id = dictionary.get("AccountId") if dictionary.get("AccountId") else APIHelper.SKIP
        pan = dictionary.get("PAN") if dictionary.get("PAN") else APIHelper.SKIP
        panid = dictionary.get("PANID") if dictionary.get("PANID") else APIHelper.SKIP
        card_id = dictionary.get("CardId") if dictionary.get("CardId") else APIHelper.SKIP
        # Return an object of this model
        return cls(reissue_setting,
                   account_number,
                   account_id,
                   pan,
                   panid,
                   card_id)
