# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper


class PINContact(object):

    """Implementation of the 'PINContact' model.

    TODO: type model description here.

    Attributes:
        delivery_contact_title (str): Title of the contact person <br />
            Optional
        delivery_contact_name (str): Name of the contact person <br />
            Mandatory - If PINAdviceType is paper else optional. <br /> Max
            field length: 50  <br /> Optional
        delivery_company_name (str): Company name <br /> Mandatory - If
            PINAdviceType is paper else optional. <br /> Max field length: 50 
            <br /> Optional
        delivery_address_line_1 (str): Address line 1 <br /> Mandatory - if
            PINAdviceType is paper else optional.<br /> Max field length: 40 
            <br /> Optional
        delivery_address_line_2 (str): Address line 2 <br /> Optional <br />
            Max field length: 40  <br /> Optional
        delivery_address_line_3 (str): Address line 3 <br /> Optional <br />
            Max field length: 40  <br /> Optional
        delivery_zip_code (str): ZIP code <br /> Mandatory - if PINAdviceType
            is paper else optional. <br /> Max field length: 10  <br />
            Optional
        delivery_city (str): City  <br /> Mandatory - If PINAdviceType is
            paper else optional. <br /> Max field length: 40  <br /> Optional
        delivery_region_id (int): Region Id  <br /> Optional
        delivery_region (str): Region  <br /> Optional<br />
        delivery_country (str): The ISO code of the country.<br /> Mandatory
            if PINAdviceType is paper else optional.
        phone_number (str): Phone number for to send SMS of the PIN in case
            PINAdviceType is SMS.<br /> Mandatory if PINAdviceType is SMS else
            optional.<br /> Max field length: 20
        email_address (str): Email address for to send email of the PIN in
            case PINAdviceType is Email.<br /> Mandatory if PINAdviceType is
            email else optional.<br /> Max field length: 90. <br/>Note:Based
            on the international standard that there can be Max Length 64
            before the @ (the 'Local part’) =64(minimum of 1) Max Lenth after
            the (the domain) = 88 (Minimum of 2)
        save_for_pin_reminder (bool): The given address will be used for
            sending PIN reminders in future when requested.<br /> Only allowed
            for paper delivery<br /> Optional

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "delivery_contact_title": 'DeliveryContactTitle',
        "delivery_contact_name": 'DeliveryContactName',
        "delivery_company_name": 'DeliveryCompanyName',
        "delivery_address_line_1": 'DeliveryAddressLine1',
        "delivery_address_line_2": 'DeliveryAddressLine2',
        "delivery_address_line_3": 'DeliveryAddressLine3',
        "delivery_zip_code": 'DeliveryZipCode',
        "delivery_city": 'DeliveryCity',
        "delivery_region_id": 'DeliveryRegionId',
        "delivery_region": 'DeliveryRegion',
        "delivery_country": 'DeliveryCountry',
        "phone_number": 'PhoneNumber',
        "email_address": 'EmailAddress',
        "save_for_pin_reminder": 'SaveForPINReminder'
    }

    _optionals = [
        'delivery_contact_title',
        'delivery_contact_name',
        'delivery_company_name',
        'delivery_address_line_1',
        'delivery_address_line_2',
        'delivery_address_line_3',
        'delivery_zip_code',
        'delivery_city',
        'delivery_region_id',
        'delivery_region',
        'delivery_country',
        'phone_number',
        'email_address',
        'save_for_pin_reminder',
    ]

    _nullables = [
        'delivery_contact_title',
        'delivery_contact_name',
        'delivery_company_name',
        'delivery_address_line_1',
        'delivery_address_line_2',
        'delivery_address_line_3',
        'delivery_zip_code',
        'delivery_city',
        'delivery_region_id',
        'delivery_region',
        'delivery_country',
        'phone_number',
        'email_address',
    ]

    def __init__(self,
                 delivery_contact_title=APIHelper.SKIP,
                 delivery_contact_name=APIHelper.SKIP,
                 delivery_company_name=APIHelper.SKIP,
                 delivery_address_line_1=APIHelper.SKIP,
                 delivery_address_line_2=APIHelper.SKIP,
                 delivery_address_line_3=APIHelper.SKIP,
                 delivery_zip_code=APIHelper.SKIP,
                 delivery_city=APIHelper.SKIP,
                 delivery_region_id=APIHelper.SKIP,
                 delivery_region=APIHelper.SKIP,
                 delivery_country=APIHelper.SKIP,
                 phone_number=APIHelper.SKIP,
                 email_address=APIHelper.SKIP,
                 save_for_pin_reminder=APIHelper.SKIP):
        """Constructor for the PINContact class"""

        # Initialize members of the class
        if delivery_contact_title is not APIHelper.SKIP:
            self.delivery_contact_title = delivery_contact_title 
        if delivery_contact_name is not APIHelper.SKIP:
            self.delivery_contact_name = delivery_contact_name 
        if delivery_company_name is not APIHelper.SKIP:
            self.delivery_company_name = delivery_company_name 
        if delivery_address_line_1 is not APIHelper.SKIP:
            self.delivery_address_line_1 = delivery_address_line_1 
        if delivery_address_line_2 is not APIHelper.SKIP:
            self.delivery_address_line_2 = delivery_address_line_2 
        if delivery_address_line_3 is not APIHelper.SKIP:
            self.delivery_address_line_3 = delivery_address_line_3 
        if delivery_zip_code is not APIHelper.SKIP:
            self.delivery_zip_code = delivery_zip_code 
        if delivery_city is not APIHelper.SKIP:
            self.delivery_city = delivery_city 
        if delivery_region_id is not APIHelper.SKIP:
            self.delivery_region_id = delivery_region_id 
        if delivery_region is not APIHelper.SKIP:
            self.delivery_region = delivery_region 
        if delivery_country is not APIHelper.SKIP:
            self.delivery_country = delivery_country 
        if phone_number is not APIHelper.SKIP:
            self.phone_number = phone_number 
        if email_address is not APIHelper.SKIP:
            self.email_address = email_address 
        if save_for_pin_reminder is not APIHelper.SKIP:
            self.save_for_pin_reminder = save_for_pin_reminder 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        delivery_contact_title = dictionary.get("DeliveryContactTitle") if "DeliveryContactTitle" in dictionary.keys() else APIHelper.SKIP
        delivery_contact_name = dictionary.get("DeliveryContactName") if "DeliveryContactName" in dictionary.keys() else APIHelper.SKIP
        delivery_company_name = dictionary.get("DeliveryCompanyName") if "DeliveryCompanyName" in dictionary.keys() else APIHelper.SKIP
        delivery_address_line_1 = dictionary.get("DeliveryAddressLine1") if "DeliveryAddressLine1" in dictionary.keys() else APIHelper.SKIP
        delivery_address_line_2 = dictionary.get("DeliveryAddressLine2") if "DeliveryAddressLine2" in dictionary.keys() else APIHelper.SKIP
        delivery_address_line_3 = dictionary.get("DeliveryAddressLine3") if "DeliveryAddressLine3" in dictionary.keys() else APIHelper.SKIP
        delivery_zip_code = dictionary.get("DeliveryZipCode") if "DeliveryZipCode" in dictionary.keys() else APIHelper.SKIP
        delivery_city = dictionary.get("DeliveryCity") if "DeliveryCity" in dictionary.keys() else APIHelper.SKIP
        delivery_region_id = dictionary.get("DeliveryRegionId") if "DeliveryRegionId" in dictionary.keys() else APIHelper.SKIP
        delivery_region = dictionary.get("DeliveryRegion") if "DeliveryRegion" in dictionary.keys() else APIHelper.SKIP
        delivery_country = dictionary.get("DeliveryCountry") if "DeliveryCountry" in dictionary.keys() else APIHelper.SKIP
        phone_number = dictionary.get("PhoneNumber") if "PhoneNumber" in dictionary.keys() else APIHelper.SKIP
        email_address = dictionary.get("EmailAddress") if "EmailAddress" in dictionary.keys() else APIHelper.SKIP
        save_for_pin_reminder = dictionary.get("SaveForPINReminder") if "SaveForPINReminder" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(delivery_contact_title,
                   delivery_contact_name,
                   delivery_company_name,
                   delivery_address_line_1,
                   delivery_address_line_2,
                   delivery_address_line_3,
                   delivery_zip_code,
                   delivery_city,
                   delivery_region_id,
                   delivery_region,
                   delivery_country,
                   phone_number,
                   email_address,
                   save_for_pin_reminder)
