# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper
from shellcardmanagementapis.models.search_card import SearchCard


class SearchRequest(object):

    """Implementation of the 'SearchRequest' model.

    Encapsulate the Search details request.

    Attributes:
        account_id (int): Account ID of the customer.<br/> Optional.<br/> This
            input is a search criterion, if given.
        account_number (str): Account Number of the customer.<br/>
            Optional.<br/> This input is a search criterion, if given.
        card_group_id (int): Card group id. <br /> Optional.<br /> This input
            is a search criterion, if given.<br /> When -1 is passed, those
            cards that does not belong to any card group will be returned.
        card_group_name (str): Card group name.<br /> Optional.<br /> This
            input is a search criterion, if given.<br /> If CardGroupId is
            provided then this search criterion will be ignored, else, those
            cards that have the card group name completely matching with the
            entered value will be returned.
        card_segment (str): Market segment to which card belongs to.<br />
            Optional.<br /> Allowed values<br /> • CRT<br /> • Fleet
        card_status (List[str]): Status of the card.<br /> Mandatory.<br />
            Multiple statuses are allowed to be included in the search
            criteria.<br /> CardStatus filter accepts either of the two values
            for each status as described below. However, the output field
            “StatusDescription” is aligned with second value highlighted in
            italics.<br /> Below are the possible allowed statuses: <br /> •
            ACTIVE or Active – Cards at status Active if the
            IncludeIntermediateStatus flag is true: Active (Block in
            progress), Active (Cancel in progress), Active (Marked as
            damaged)), New (Cancel in progress).<br /> • ON_ORDER or New –
            Cards at status New<br /> • EXPIRED or Expired – Cards at status
            Expired<br /> • BLOCKED or Blocked Card – Cards at status Block
            (The result will include all cards having the following
            intermediate status, if the IncludeIntermediateStatus flag is
            true: Blocked card (Unblock in progress))<br /> •
            TEMP_BLOCKED_CUSTOMER or Temporary Block(Customer) – Cards at
            status Temporary Blocked By Customer<br /> • TEMP_BLOCKED_SHELL or
            Temporary Block (Shell) – Cards at Status Temporary Blocked by
            Shell<br /> • CANCELLED or Cancelled – Cards at status
            Cancelled<br /> • PENDING_RENEWAL or Pending Renewal - Cards that
            are in renewal process<br /> • REPLACED or Replaced – Cards at
            Status Replaced<br /> • FRAUD or Fraud – Cards at Status FRAUD<br
            /> • ALL
        card_type_code (str): ISO code of the card i.e. first 7 digits of the
            PAN<br /> Optional.
        col_co_code (int): Collecting Company Code (Shell Code) of the
            selected payer. <br /> Optional If ColCo Id or ColCoCountryCode is
            passed else Mandatory<br />
        col_co_country_code (str): The 2 character ISO Code for the customer
            and card owning country.<br /> Optional If ColCoId or ColCoCode is
            passed else Mandatory.<br />
        col_co_id (int): Collecting Company Id  of the selected payer. <br />
            Optional If ColCoCode or ColCoCountryCode is passed else Mandatory
            <br />
        coverage (str): Cards allowed to used nationally/internationally.<br
            /> Optional.<br /> Allowed values<br /> -National<br />
            -International
        creation_date (str): Card Creation Date<br /> Optional<br /> Format:
            yyyyMMdd
        driver_name (List[str]): Driver Name embossed on the card<br />
            Optional<br /> Up to 10 driver names could be passed in the
            parameter.<br /> Minimum of 4 characters should be provided for
            each driver name else not considered.<br /> Those cards will be
            returned when part of the driver name matches with any of the
            string passed in the list.<br /> Max Length for each Driver name:
            50
        effective_date (str): Effective date for the Card<br /> Optional<br />
            Format: yyyyMMdd<br />
        exclude_bundle_id (str): Bundle Id for the Card, which needs to be
            excluded in the response.<br /> Optional
        exclude_cancelled_cards (bool): Default value is True.<br /> When
            true, the API will not return cards that are at Cancelled Status
            in Cards Platform<br />
        exclude_card_group_id (int): Optional<br /> When passed, the API will
            not return cards that are currently in the Card Group specified<br
            />
        exclude_card_group_name (str): Optional<br /> When passed, the API
            will not return cards that are currently in the Card Group
            specified<br />
        exclude_cards (List[SearchCard]): List of SearchCard entity i.e., Card
            Id or PAN, which needs to be excluded in the response. <br />
            Details of the SerachCard entity are given below.<br />
        exclude_fraud_cards (bool): Default value is False.<br /> When true,
            the API will not return cards that are at Fraud Status in Cards
            Platform<br />
        exclude_pending_renewal_cards (bool): Default value is True.<br />
            When true, the API will not return cards that are at Pending
            Renewal Status in Cards Platform
        exclude_replaced_cards (bool): Default value is False.<br /> When
            true, the API will not return cards that are at Replaced Status in
            Cards Platform<br />
        expiring_in_days (int): Cards active and expiring in given number of
            days.<br /> Optional<br /> Note: When a value is passed in this
            parameter, only active cards will be considered while
            searching.<br />
        expiry_month (str): Month in which the card is expiring.<br />
            Optional.<br /> Format: MMYYYY<br />
        include_bundle_details (bool): Default value is False,<br /> When the
            value is True, API will return bundle Id associated with card in
            response.<br />
        include_cards (List[SearchCard]): List of SearchCard entity i.e., Card
            Id or PAN, which needs to be included in the response.<br />
            Details of the SerachCard entity are given below.<br />
        include_intermediate_status (bool): A flag which indicates if the
            response can contain intermediate statuses.<br /> Optional<br />
            Default: false
        issued_after (str): If provided, only list cards issued after the
            given date<br /> Optional<br /> Format: yyyyMMdd<br /> Note:
            Clients to convert this to appropriate DateTime type.
        network (str): Cards allowed to be used in site.<br /> Optional.<br />
            Allowed values<br /> -ShellSitesOnly<br /> -PartnersSitesIncluded
        pan_ends_with (str): Last digits of the PAN number<br /> Minimum 4
            last digits of the card should be sent for this field to be
            considered as part of the search criteria.<br /> Optional<br />
            Max Length: 50
        payer_id (int): Payer Id (i.e. Customer Id of the Payment Customer) of
            the selected payer.<br /> Optional if PayerNumber is passed else
            Mandatory<br /> Example: 123456
        payer_number (str): Payer Number of the selected payer.<br /> Optional
            if PayerId is passed else Mandatory<br />
        purchase_category_code (str): Purchase category code of the card.<br
            /> Optional.
        sort_order (str): Possible options are:<br />
            1.ExpiringDateAscending<br /> 2.ExpiringDateDescending<br />
            3.DriverNameAscending(If Driver Name is null then VRN value will
            be considered)<br /> 4.DriverNameDescending(If Driver Name is null
            then VRN value will be considered)<br /> 5.VRNAscending(If VRN is
            null then Driver Name value will be considered)<br />
            6.VRNDescending(If VRN  is null then Driver Name value will be
            considered)<br /> 7.LastUsedDateAscending<br />
            8.LastUsedDateDescending<br /> 9.IssueDateAscending<br />
            10.IssueDateDescending<br /> 11.PurchaseCategoryCodeAscending<br
            /> 12.PurchaseCategoryCodeDescending<br /> 13.CardSegmentAscending
            (CRT will appear first)<br /> 14.CardSegmentDescending (Fleet will
            appear first)<br /> Optional
        include_scheduled_card_blocks (bool): A flag which indicates if the
            response can contain scheduled card blocks details<br />
            Optional<br /> Default: false
        token_type_id (int): Token Type ID for the Card<br /> Optional
        token_type_name (str): Token Type name for the Card<br /> Optional
        vehicle_registration_number (List[str]): Vehicle Registration embossed
            on the card<br /> Optional<br /> Up to 10 vehicle registration
            numbers could be passed in the parameter.<br /> Minimum of 4
            characters should be provided for each VRN else not considered<br
            /> Those cards will be returned when part of the VRN matches with
            any of the string passed in the list.<br /> Max Length for each
            VRN: 50
        exclude_old_cards (bool): Default Value: False<br /> When this field
            is set to True, cards with below status 2 years (configurable) ago
            and earlier are excluded from the result<br /> -Blocked Card<br />
            -Expired<br /> -Cancelled<br /> -Suspended<br /> -Blocked<br />
            -Expired and Cancelled<br /> -Replaced<br /> -Replaced By<br />
            -Closed<br /> -Fraud<br />
        exclude_expiring_cards (bool): Default value is False.<br /> When
            true, the API will not return cards that are expiring <br />
            within 120 (i.e. Configured) days, if the status of the card is 1
            or 41 or 42 in Cards platform.
        client_reference_id (str): Customer reference number of the card.
        reissue_setting (str): Default Value: All<br /> Optional<br /> This
            option is used to filter the list of cards with
            ‘ReissueSetting’.<br /> If ‘True’, the API will return cards with
            ReIssueSetting value is true.<br /> If ‘False’, the API will
            return cards with ReIsssueSetting value is false.<br /> If ‘ALL’,
            API will return cards with ReIssueSetting value True &amp; False
            both.<br /> Allowed Values:<br /> 1.    All<br /> 2.    True<br />
            3.    False
        request_id (str): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "card_status": 'CardStatus',
        "account_id": 'AccountId',
        "account_number": 'AccountNumber',
        "card_group_id": 'CardGroupId',
        "card_group_name": 'CardGroupName',
        "card_segment": 'CardSegment',
        "card_type_code": 'CardTypeCode',
        "col_co_code": 'ColCoCode',
        "col_co_country_code": 'ColCoCountryCode',
        "col_co_id": 'ColCoId',
        "coverage": 'Coverage',
        "creation_date": 'CreationDate',
        "driver_name": 'DriverName',
        "effective_date": 'EffectiveDate',
        "exclude_bundle_id": 'ExcludeBundleId',
        "exclude_cancelled_cards": 'ExcludeCancelledCards',
        "exclude_card_group_id": 'ExcludeCardGroupId',
        "exclude_card_group_name": 'ExcludeCardGroupName',
        "exclude_cards": 'ExcludeCards',
        "exclude_fraud_cards": 'ExcludeFraudCards',
        "exclude_pending_renewal_cards": 'ExcludePendingRenewalCards',
        "exclude_replaced_cards": 'ExcludeReplacedCards',
        "expiring_in_days": 'ExpiringInDays',
        "expiry_month": 'ExpiryMonth',
        "include_bundle_details": 'IncludeBundleDetails',
        "include_cards": 'IncludeCards',
        "include_intermediate_status": 'IncludeIntermediateStatus',
        "issued_after": 'IssuedAfter',
        "network": 'Network',
        "pan_ends_with": 'PANEndsWith',
        "payer_id": 'PayerId',
        "payer_number": 'PayerNumber',
        "purchase_category_code": 'PurchaseCategoryCode',
        "sort_order": 'SortOrder',
        "include_scheduled_card_blocks": 'IncludeScheduledCardBlocks',
        "token_type_id": 'TokenTypeID',
        "token_type_name": 'TokenTypeName',
        "vehicle_registration_number": 'VehicleRegistrationNumber',
        "exclude_old_cards": 'ExcludeOldCards',
        "exclude_expiring_cards": 'ExcludeExpiringCards',
        "client_reference_id": 'ClientReferenceId',
        "reissue_setting": 'ReissueSetting',
        "request_id": 'RequestId'
    }

    _optionals = [
        'account_id',
        'account_number',
        'card_group_id',
        'card_group_name',
        'card_segment',
        'card_type_code',
        'col_co_code',
        'col_co_country_code',
        'col_co_id',
        'coverage',
        'creation_date',
        'driver_name',
        'effective_date',
        'exclude_bundle_id',
        'exclude_cancelled_cards',
        'exclude_card_group_id',
        'exclude_card_group_name',
        'exclude_cards',
        'exclude_fraud_cards',
        'exclude_pending_renewal_cards',
        'exclude_replaced_cards',
        'expiring_in_days',
        'expiry_month',
        'include_bundle_details',
        'include_cards',
        'include_intermediate_status',
        'issued_after',
        'network',
        'pan_ends_with',
        'payer_id',
        'payer_number',
        'purchase_category_code',
        'sort_order',
        'include_scheduled_card_blocks',
        'token_type_id',
        'token_type_name',
        'vehicle_registration_number',
        'exclude_old_cards',
        'exclude_expiring_cards',
        'client_reference_id',
        'reissue_setting',
        'request_id',
    ]

    _nullables = [
        'account_id',
        'account_number',
        'card_group_id',
        'card_group_name',
        'card_segment',
        'card_type_code',
        'col_co_code',
        'col_co_country_code',
        'col_co_id',
        'coverage',
        'creation_date',
        'effective_date',
        'exclude_bundle_id',
        'exclude_card_group_id',
        'exclude_card_group_name',
        'expiring_in_days',
        'expiry_month',
        'issued_after',
        'network',
        'pan_ends_with',
        'payer_id',
        'payer_number',
        'purchase_category_code',
        'sort_order',
        'token_type_id',
        'token_type_name',
        'client_reference_id',
        'reissue_setting',
    ]

    def __init__(self,
                 card_status=None,
                 account_id=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 card_group_id=APIHelper.SKIP,
                 card_group_name=APIHelper.SKIP,
                 card_segment=APIHelper.SKIP,
                 card_type_code=APIHelper.SKIP,
                 col_co_code=APIHelper.SKIP,
                 col_co_country_code=APIHelper.SKIP,
                 col_co_id=APIHelper.SKIP,
                 coverage=APIHelper.SKIP,
                 creation_date=APIHelper.SKIP,
                 driver_name=APIHelper.SKIP,
                 effective_date=APIHelper.SKIP,
                 exclude_bundle_id=APIHelper.SKIP,
                 exclude_cancelled_cards=APIHelper.SKIP,
                 exclude_card_group_id=APIHelper.SKIP,
                 exclude_card_group_name=APIHelper.SKIP,
                 exclude_cards=APIHelper.SKIP,
                 exclude_fraud_cards=APIHelper.SKIP,
                 exclude_pending_renewal_cards=APIHelper.SKIP,
                 exclude_replaced_cards=APIHelper.SKIP,
                 expiring_in_days=APIHelper.SKIP,
                 expiry_month=APIHelper.SKIP,
                 include_bundle_details=APIHelper.SKIP,
                 include_cards=APIHelper.SKIP,
                 include_intermediate_status=APIHelper.SKIP,
                 issued_after=APIHelper.SKIP,
                 network=APIHelper.SKIP,
                 pan_ends_with=APIHelper.SKIP,
                 payer_id=APIHelper.SKIP,
                 payer_number=APIHelper.SKIP,
                 purchase_category_code=APIHelper.SKIP,
                 sort_order=APIHelper.SKIP,
                 include_scheduled_card_blocks=APIHelper.SKIP,
                 token_type_id=APIHelper.SKIP,
                 token_type_name=APIHelper.SKIP,
                 vehicle_registration_number=APIHelper.SKIP,
                 exclude_old_cards=APIHelper.SKIP,
                 exclude_expiring_cards=APIHelper.SKIP,
                 client_reference_id=APIHelper.SKIP,
                 reissue_setting=APIHelper.SKIP,
                 request_id=APIHelper.SKIP):
        """Constructor for the SearchRequest class"""

        # Initialize members of the class
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if card_group_id is not APIHelper.SKIP:
            self.card_group_id = card_group_id 
        if card_group_name is not APIHelper.SKIP:
            self.card_group_name = card_group_name 
        if card_segment is not APIHelper.SKIP:
            self.card_segment = card_segment 
        self.card_status = card_status 
        if card_type_code is not APIHelper.SKIP:
            self.card_type_code = card_type_code 
        if col_co_code is not APIHelper.SKIP:
            self.col_co_code = col_co_code 
        if col_co_country_code is not APIHelper.SKIP:
            self.col_co_country_code = col_co_country_code 
        if col_co_id is not APIHelper.SKIP:
            self.col_co_id = col_co_id 
        if coverage is not APIHelper.SKIP:
            self.coverage = coverage 
        if creation_date is not APIHelper.SKIP:
            self.creation_date = creation_date 
        if driver_name is not APIHelper.SKIP:
            self.driver_name = driver_name 
        if effective_date is not APIHelper.SKIP:
            self.effective_date = effective_date 
        if exclude_bundle_id is not APIHelper.SKIP:
            self.exclude_bundle_id = exclude_bundle_id 
        if exclude_cancelled_cards is not APIHelper.SKIP:
            self.exclude_cancelled_cards = exclude_cancelled_cards 
        if exclude_card_group_id is not APIHelper.SKIP:
            self.exclude_card_group_id = exclude_card_group_id 
        if exclude_card_group_name is not APIHelper.SKIP:
            self.exclude_card_group_name = exclude_card_group_name 
        if exclude_cards is not APIHelper.SKIP:
            self.exclude_cards = exclude_cards 
        if exclude_fraud_cards is not APIHelper.SKIP:
            self.exclude_fraud_cards = exclude_fraud_cards 
        if exclude_pending_renewal_cards is not APIHelper.SKIP:
            self.exclude_pending_renewal_cards = exclude_pending_renewal_cards 
        if exclude_replaced_cards is not APIHelper.SKIP:
            self.exclude_replaced_cards = exclude_replaced_cards 
        if expiring_in_days is not APIHelper.SKIP:
            self.expiring_in_days = expiring_in_days 
        if expiry_month is not APIHelper.SKIP:
            self.expiry_month = expiry_month 
        if include_bundle_details is not APIHelper.SKIP:
            self.include_bundle_details = include_bundle_details 
        if include_cards is not APIHelper.SKIP:
            self.include_cards = include_cards 
        if include_intermediate_status is not APIHelper.SKIP:
            self.include_intermediate_status = include_intermediate_status 
        if issued_after is not APIHelper.SKIP:
            self.issued_after = issued_after 
        if network is not APIHelper.SKIP:
            self.network = network 
        if pan_ends_with is not APIHelper.SKIP:
            self.pan_ends_with = pan_ends_with 
        if payer_id is not APIHelper.SKIP:
            self.payer_id = payer_id 
        if payer_number is not APIHelper.SKIP:
            self.payer_number = payer_number 
        if purchase_category_code is not APIHelper.SKIP:
            self.purchase_category_code = purchase_category_code 
        if sort_order is not APIHelper.SKIP:
            self.sort_order = sort_order 
        if include_scheduled_card_blocks is not APIHelper.SKIP:
            self.include_scheduled_card_blocks = include_scheduled_card_blocks 
        if token_type_id is not APIHelper.SKIP:
            self.token_type_id = token_type_id 
        if token_type_name is not APIHelper.SKIP:
            self.token_type_name = token_type_name 
        if vehicle_registration_number is not APIHelper.SKIP:
            self.vehicle_registration_number = vehicle_registration_number 
        if exclude_old_cards is not APIHelper.SKIP:
            self.exclude_old_cards = exclude_old_cards 
        if exclude_expiring_cards is not APIHelper.SKIP:
            self.exclude_expiring_cards = exclude_expiring_cards 
        if client_reference_id is not APIHelper.SKIP:
            self.client_reference_id = client_reference_id 
        if reissue_setting is not APIHelper.SKIP:
            self.reissue_setting = reissue_setting 
        if request_id is not APIHelper.SKIP:
            self.request_id = request_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        card_status = dictionary.get("CardStatus") if dictionary.get("CardStatus") else None
        account_id = dictionary.get("AccountId") if "AccountId" in dictionary.keys() else APIHelper.SKIP
        account_number = dictionary.get("AccountNumber") if "AccountNumber" in dictionary.keys() else APIHelper.SKIP
        card_group_id = dictionary.get("CardGroupId") if "CardGroupId" in dictionary.keys() else APIHelper.SKIP
        card_group_name = dictionary.get("CardGroupName") if "CardGroupName" in dictionary.keys() else APIHelper.SKIP
        card_segment = dictionary.get("CardSegment") if "CardSegment" in dictionary.keys() else APIHelper.SKIP
        card_type_code = dictionary.get("CardTypeCode") if "CardTypeCode" in dictionary.keys() else APIHelper.SKIP
        col_co_code = dictionary.get("ColCoCode") if "ColCoCode" in dictionary.keys() else APIHelper.SKIP
        col_co_country_code = dictionary.get("ColCoCountryCode") if "ColCoCountryCode" in dictionary.keys() else APIHelper.SKIP
        col_co_id = dictionary.get("ColCoId") if "ColCoId" in dictionary.keys() else APIHelper.SKIP
        coverage = dictionary.get("Coverage") if "Coverage" in dictionary.keys() else APIHelper.SKIP
        creation_date = dictionary.get("CreationDate") if "CreationDate" in dictionary.keys() else APIHelper.SKIP
        driver_name = dictionary.get("DriverName") if dictionary.get("DriverName") else APIHelper.SKIP
        effective_date = dictionary.get("EffectiveDate") if "EffectiveDate" in dictionary.keys() else APIHelper.SKIP
        exclude_bundle_id = dictionary.get("ExcludeBundleId") if "ExcludeBundleId" in dictionary.keys() else APIHelper.SKIP
        exclude_cancelled_cards = dictionary.get("ExcludeCancelledCards") if "ExcludeCancelledCards" in dictionary.keys() else APIHelper.SKIP
        exclude_card_group_id = dictionary.get("ExcludeCardGroupId") if "ExcludeCardGroupId" in dictionary.keys() else APIHelper.SKIP
        exclude_card_group_name = dictionary.get("ExcludeCardGroupName") if "ExcludeCardGroupName" in dictionary.keys() else APIHelper.SKIP
        exclude_cards = None
        if dictionary.get('ExcludeCards') is not None:
            exclude_cards = [SearchCard.from_dictionary(x) for x in dictionary.get('ExcludeCards')]
        else:
            exclude_cards = APIHelper.SKIP
        exclude_fraud_cards = dictionary.get("ExcludeFraudCards") if "ExcludeFraudCards" in dictionary.keys() else APIHelper.SKIP
        exclude_pending_renewal_cards = dictionary.get("ExcludePendingRenewalCards") if "ExcludePendingRenewalCards" in dictionary.keys() else APIHelper.SKIP
        exclude_replaced_cards = dictionary.get("ExcludeReplacedCards") if "ExcludeReplacedCards" in dictionary.keys() else APIHelper.SKIP
        expiring_in_days = dictionary.get("ExpiringInDays") if "ExpiringInDays" in dictionary.keys() else APIHelper.SKIP
        expiry_month = dictionary.get("ExpiryMonth") if "ExpiryMonth" in dictionary.keys() else APIHelper.SKIP
        include_bundle_details = dictionary.get("IncludeBundleDetails") if "IncludeBundleDetails" in dictionary.keys() else APIHelper.SKIP
        include_cards = None
        if dictionary.get('IncludeCards') is not None:
            include_cards = [SearchCard.from_dictionary(x) for x in dictionary.get('IncludeCards')]
        else:
            include_cards = APIHelper.SKIP
        include_intermediate_status = dictionary.get("IncludeIntermediateStatus") if "IncludeIntermediateStatus" in dictionary.keys() else APIHelper.SKIP
        issued_after = dictionary.get("IssuedAfter") if "IssuedAfter" in dictionary.keys() else APIHelper.SKIP
        network = dictionary.get("Network") if "Network" in dictionary.keys() else APIHelper.SKIP
        pan_ends_with = dictionary.get("PANEndsWith") if "PANEndsWith" in dictionary.keys() else APIHelper.SKIP
        payer_id = dictionary.get("PayerId") if "PayerId" in dictionary.keys() else APIHelper.SKIP
        payer_number = dictionary.get("PayerNumber") if "PayerNumber" in dictionary.keys() else APIHelper.SKIP
        purchase_category_code = dictionary.get("PurchaseCategoryCode") if "PurchaseCategoryCode" in dictionary.keys() else APIHelper.SKIP
        sort_order = dictionary.get("SortOrder") if "SortOrder" in dictionary.keys() else APIHelper.SKIP
        include_scheduled_card_blocks = dictionary.get("IncludeScheduledCardBlocks") if "IncludeScheduledCardBlocks" in dictionary.keys() else APIHelper.SKIP
        token_type_id = dictionary.get("TokenTypeID") if "TokenTypeID" in dictionary.keys() else APIHelper.SKIP
        token_type_name = dictionary.get("TokenTypeName") if "TokenTypeName" in dictionary.keys() else APIHelper.SKIP
        vehicle_registration_number = dictionary.get("VehicleRegistrationNumber") if dictionary.get("VehicleRegistrationNumber") else APIHelper.SKIP
        exclude_old_cards = dictionary.get("ExcludeOldCards") if "ExcludeOldCards" in dictionary.keys() else APIHelper.SKIP
        exclude_expiring_cards = dictionary.get("ExcludeExpiringCards") if "ExcludeExpiringCards" in dictionary.keys() else APIHelper.SKIP
        client_reference_id = dictionary.get("ClientReferenceId") if "ClientReferenceId" in dictionary.keys() else APIHelper.SKIP
        reissue_setting = dictionary.get("ReissueSetting") if "ReissueSetting" in dictionary.keys() else APIHelper.SKIP
        request_id = dictionary.get("RequestId") if dictionary.get("RequestId") else APIHelper.SKIP
        # Return an object of this model
        return cls(card_status,
                   account_id,
                   account_number,
                   card_group_id,
                   card_group_name,
                   card_segment,
                   card_type_code,
                   col_co_code,
                   col_co_country_code,
                   col_co_id,
                   coverage,
                   creation_date,
                   driver_name,
                   effective_date,
                   exclude_bundle_id,
                   exclude_cancelled_cards,
                   exclude_card_group_id,
                   exclude_card_group_name,
                   exclude_cards,
                   exclude_fraud_cards,
                   exclude_pending_renewal_cards,
                   exclude_replaced_cards,
                   expiring_in_days,
                   expiry_month,
                   include_bundle_details,
                   include_cards,
                   include_intermediate_status,
                   issued_after,
                   network,
                   pan_ends_with,
                   payer_id,
                   payer_number,
                   purchase_category_code,
                   sort_order,
                   include_scheduled_card_blocks,
                   token_type_id,
                   token_type_name,
                   vehicle_registration_number,
                   exclude_old_cards,
                   exclude_expiring_cards,
                   client_reference_id,
                   reissue_setting,
                   request_id)
